with gb; use gb;
with gb.OleInterfaces;

with Win32, Win32.WinDef, Win32.WinMain, Win32.WinUser, Win32.WinError, System;
with Win32.WinGDI, Win32.WinBase, Win32.WinNT, Win32.Utils, Interfaces.C;
use  Win32, Win32.WinError, Interfaces.C, System;

package Principale is
  Form            : aliased gb.MainWindow;
  Bouton_Quitter  : aliased gb.Button;
  Titre           : aliased gb.Label;
  Boite_Saisie    : aliased gb.TextBox(Alignment => Left, AutoScroll => Both, 
                                       MultiLine => gb.False, Password => gb.False, 
                                       ReadOnly => gb.False);
  Texte_Rouge     : aliased gb.RadioButton;
  Texte_Italique  : aliased gb.RadioButton;
  Texte_Gras      : aliased gb.RadioButton;
  Texte_Saisi     : aliased gb.Label;
  procedure Initialize_Form;
end Principale;


package body Principale is
  procedure Bouton_Quitter_Click is
  begin
  
    -- fin de l'application
    gb.EndApplication;
    
  end Bouton_Quitter_Click;

  procedure Titre_MouseMove(Button : gb.MOUSEBUTTON_t; Shift : gb.BOOL; X : gb.INT; Y : gb.INT) is
  begin
  
  Hide (Principale.titre);
  
  end Titre_MouseMove;

  procedure Boite_Saisie_Changed is
  
  begin
  
  -- ecrit dans Principale.Texte_Saisi la chane qui se trouve 
  -- dans Principale.Boite_Saisie  chaque fois qu'elle est modifie 
  Text (Principale.Texte_Saisi, Text (Principale.Boite_Saisie));
    
  end Boite_Saisie_Changed;

  procedure Texte_Rouge_Click is
  
  begin
  
  -- si le bouton est slectionn
  if Checked (Principale.Texte_Rouge) = 1 then
  -- changer la couleur du texte
  ForeColor (Principale.Texte_Saisi, Red);
  
  -- rtablir le format ventuellement prsent d  une prcdente slection
  FontItalic (Principale.Texte_Saisi,0);
  FontBold (Principale.Texte_Saisi,0);
  
  -- dslectionner les autres boutons
  Checked (Principale.Texte_Italique,0);
  Checked (Principale.Texte_Gras,0); 
  
  end if;
  
  end Texte_Rouge_Click;

  procedure Texte_Italique_Click is
  begin
  
  if Checked (Principale.Texte_Italique) = 1 then
  
  FontItalic (Principale.Texte_Saisi, 1);
  
  ForeColor (Principale.Texte_Saisi, Black);
  FontBold (Principale.Texte_Saisi, 0);
  
  Checked (Principale.Texte_Rouge, 0);
  Checked (Principale.Texte_Gras, 0);
  
  end if;
  
  end Texte_Italique_Click;

  procedure Texte_Gras_Click is
  begin
  
  if Checked (Principale.Texte_Gras) = 1 then
  
  FontBold (Principale.Texte_Saisi, 1);
  
  ForeColor (Principale.Texte_Saisi, Black);
  FontItalic (Principale.Texte_Saisi, 0);
  
  Checked (Principale.Texte_Rouge, 0);
  Checked (Principale.Texte_Italique, 0);
  
  end if;
  
  end Texte_Gras_Click;

  procedure Texte_Saisi_MouseDown(Button : gb.MOUSEBUTTON_t; Shift : gb.BOOL; X : gb.INT; Y : gb.INT) is
  begin
  
  -- doublez les valeurs de dpart
  Height(Principale.Texte_Saisi, 62);
  Width (Principale.Texte_Saisi, 702);
  FontSize (Principale.Texte_Saisi, 25);
  
  end Texte_Saisi_MouseDown;

  procedure Texte_Saisi_MouseUp(Button : gb.MOUSEBUTTON_t; Shift : gb.BOOL; X : gb.INT; Y : gb.INT) is
  begin
  
  -- doivent tre les valeurs de dpart!
  Height (Principale.Texte_Saisi, 31);
  Width (Principale.Texte_Saisi, 351);
  FontSize (Principale.Texte_Saisi, 9);
  
  end Texte_Saisi_MouseUp;

  procedure Form_MouseMove(Button : gb.MOUSEBUTTON_t; Shift : gb.BOOL; X : gb.INT; Y : gb.INT) is
  begin
  
  
  Show (Principale.titre);
  
  end Form_MouseMove;

  procedure Initialize_Form is
  begin
    Bouton_Quitter.Click := Bouton_Quitter_Click'Access;
    Caption(Bouton_Quitter, "Quitter");
    SetFont(Bouton_Quitter, "Times New Roman", 12, gb.False, gb.False, gb.False);
    Move(Bouton_Quitter, 169, 324, 100, 50);

    Titre.MouseMove := Titre_MouseMove'Access;
    Caption(Titre, "Mon application GUI Builder");
    Alignment(Titre, gb.Center);
    SetFont(Titre, "Times New Roman", 18, gb.False, gb.False, gb.False);
    SetColors(Titre, Color(0, 128, 255), Color(192, 192, 192));
    Move(Titre, 60, 50, 351, 31);

    Boite_Saisie.Changed := Boite_Saisie_Changed'Access;
    Text(Boite_Saisie, "");
    Move(Boite_Saisie, 60, 100, 351, 31);

    Texte_Rouge.Click := Texte_Rouge_Click'Access;
    Caption(Texte_Rouge, "Texte rouge");
    TabStop(Texte_Rouge, gb.False);
    Move(Texte_Rouge, 160, 200, 171, 21);

    Texte_Italique.Click := Texte_Italique_Click'Access;
    Caption(Texte_Italique, "Texte italique");
    TabStop(Texte_Italique, gb.False);
    Move(Texte_Italique, 160, 240, 171, 21);

    Texte_Gras.Click := Texte_Gras_Click'Access;
    Caption(Texte_Gras, "Texte gras");
    TabStop(Texte_Gras, gb.False);
    Move(Texte_Gras, 160, 280, 171, 21);

    Texte_Saisi.MouseDown := Texte_Saisi_MouseDown'Access;
    Texte_Saisi.MouseUp := Texte_Saisi_MouseUp'Access;
    Caption(Texte_Saisi, "Texte saisi dans la boite Boite_Saisie");
    Move(Texte_Saisi, 60, 150, 351, 31);

    Form.MouseMove := Form_MouseMove'Access;
    Caption(Form, "Accueil");
    ControlBox(Form, gb.False);
    MaxButton(Form, gb.False);
    MinButton(Form, gb.False);
    Move(Form, 33, 276, 500, 500);
    Visible(Form, gb.True);
  end Initialize_Form;
begin
  Initialize_Form;
end Principale;


with gb;
with Principale;

procedure Main is begin
  gb.StartApplication;
end Main;


