with gb; use gb;
with gb.OleInterfaces;

with Win32, Win32.WinDef, Win32.WinMain, Win32.WinUser, Win32.WinError, System;
with Win32.WinGDI, Win32.WinBase, Win32.WinNT, Win32.Utils, Interfaces.C;
use  Win32, Win32.WinError, Interfaces.C, System;

package Saisie is
  Form            : aliased gb.MainWindow;
  Bouton_Quitter  : aliased gb.Button;
  Bouton_Validation     : aliased gb.Button;
  Label1          : aliased gb.Label;
  Choix           : aliased gb.DropDownList(Sorted => gb.False);
  Message_Choix2  : aliased gb.Label;
  Bouton_Retour_Choix2  : aliased gb.Button;
  procedure Initialize_Form;
end Saisie;

with Choix1;
with Choix4;

package body Saisie is
  procedure Bouton_Quitter_Click is
  begin
  
  -- Fin de l'application
  Gb.endapplication;
  
  end Bouton_Quitter_Click;

  procedure Bouton_Validation_Click is
  begin
  
  -- Premier choix
  If Text(Saisie.Choix) = "Choix numro 1" then
  
    -- Faire apparatre la fentre du premier choix
    Visible(Choix1.Form,Gb.true);
    -- et disparaitre la fenetre de depart
    Visible(Saisie.Form,Gb.false);
  
  -- Deuxime choix
  elsif Text(Saisie.Choix) = "Choix numro 2" then
  
    -- Affiche une boite de message
    MsgBox ("Le deuxime choix est interdit.", "Erreur deuxime choix");  
  
  -- Troisime choix
  elsif Text(Saisie.Choix) = "Choix numro 3" then
  
    -- Faire apparatre les objets du choix 2
    Visible(Message_Choix2,Gb.true);
    Visible(Bouton_Retour_Choix2,Gb.true);
    
    -- Masquer les objets principaux de la boite de saisie du choix
    Visible(Choix, Gb.false);
    Visible(Bouton_Validation, Gb.false);
    Visible(Bouton_Quitter, Gb. false);
  
  -- Quatrime choix
  elsif Text(Saisie.Choix) = "Choix numro 4" then
  
    -- Faire apparatre la fentre du dernier choix
    Visible(Choix4.Form,Gb.true);
    -- et disparaitre la fenetre de depart
    Visible(Saisie.Form,Gb.false);
  
    
  end if;
  end Bouton_Validation_Click;

  procedure Bouton_Retour_Choix2_Click is
  begin
  
    -- Masquer les 3 objets du choix 2 
    Visible(Message_Choix2,Gb.false);
    Visible(Bouton_Retour_Choix2,Gb.false);
    
    -- Faire apparatre les objets principaux de la boite de saisie
    Visible(Choix, Gb.true);
    Visible(Bouton_Validation, Gb.true);
    Visible(Bouton_Quitter, Gb.true);
  
  end Bouton_Retour_Choix2_Click;

  procedure Initialize_Form is
  begin
    Bouton_Quitter.Click := Bouton_Quitter_Click'Access;
    Caption(Bouton_Quitter, "Quitter");
    SetFont(Bouton_Quitter, "Times New Roman", 12, gb.False, gb.False, gb.False);
    Move(Bouton_Quitter, 400, 329, 91, 41);

    Bouton_Validation.Click := Bouton_Validation_Click'Access;
    Caption(Bouton_Validation, "OK");
    Move(Bouton_Validation, 400, 259, 91, 41);

    Caption(Label1, "Parfois un choix s'impose");
    Alignment(Label1, gb.Center);
    SetFont(Label1, "MS Sans Serif", 18, gb.True, gb.False, gb.False);
    SetColors(Label1, Color(0, 0, 0), Color(0, 128, 255));
    Move(Label1, 30, 20, 441, 31);

    AddItem(Choix, "Choix numro 1");
    SelectItem(Choix, "Choix numro 1");
    AddItem(Choix, "Choix numro 2");
    AddItem(Choix, "Choix numro 3");
    AddItem(Choix, "Choix numro 4");
    Move(Choix, 60, 110, 341, 21);

    Caption(Message_Choix2, "Affiche un nouveau texte dans la mme fentre");
    Alignment(Message_Choix2, gb.Center);
    Visible(Message_Choix2, gb.False);
    SetFont(Message_Choix2, "MS Sans Serif", 10, gb.False, gb.False, gb.False);
    SetColors(Message_Choix2, Color(64, 0, 64), Color(255, 128, 64));
    Move(Message_Choix2, 35, 287, 285, 17);

    Bouton_Retour_Choix2.Click := Bouton_Retour_Choix2_Click'Access;
    Caption(Bouton_Retour_Choix2, "Retour");
    Visible(Bouton_Retour_Choix2, gb.False);
    Move(Bouton_Retour_Choix2, 118, 329, 130, 33);

    Caption(Form, "Choix de la fentre dsire");
    SetColors(Form, Color(0, 0, 0), Color(0, 128, 255));
    Move(Form, 32, 160, 522, 417);
    Visible(Form, gb.True);
  end Initialize_Form;
begin
  Initialize_Form;
end Saisie;


with gb;
with Saisie;
with Choix1;
with Choix4;

procedure Main is begin
  gb.StartApplication;
end Main;


