with gb; use gb;
with gb.OleInterfaces;

with Win32, Win32.WinDef, Win32.WinMain, Win32.WinUser, Win32.WinError, System;
with Win32.WinGDI, Win32.WinBase, Win32.WinNT, Win32.Utils, Interfaces.C;
use  Win32, Win32.WinError, Interfaces.C, System;

package Principale is
  Form            : aliased gb.MainWindow;
  HScroll2        : aliased gb.HScrollBar;
  HScroll1        : aliased gb.HScrollBar;
  Label4          : aliased gb.Label;
  Label5          : aliased gb.Label;
  Label6          : aliased gb.Label;
  Image           : aliased gb.Picture;
  Label1          : aliased gb.Label;
  Label3          : aliased gb.Label;
  Label2          : aliased gb.Label;
  Sens            : aliased gb.TwoStateButton;
  Box3            : aliased gb.Box;
  Box2            : aliased gb.Box;
  Box9            : aliased gb.Box;
  Box12           : aliased gb.Box;
  Box8            : aliased gb.Box;
  Box11           : aliased gb.Box;
  Box7            : aliased gb.Box;
  Box10           : aliased gb.Box;
  Box6            : aliased gb.Box;
  Box5            : aliased gb.Box;
  Box4            : aliased gb.Box;
  Box1            : aliased gb.Box;
  Image1          : aliased gb.Image;
  Timer1          : aliased gb.Timer;
  Timer3          : aliased gb.Timer;
  procedure Initialize_Form;
end Principale;


package body Principale is
    I : gb.Int := 1;

  procedure HScroll2_Scrolled is
  begin
  
       -- Valeur entre 
        if    Value(Principale.HScroll2) <= 1 then
          Interval (Principale.Timer3,1);
  
        elsif Value(Principale.HScroll2) <= 2 then
          Interval (Principale.Timer3,100);
  
        elsif Value(Principale.HScroll2) <= 3 then
          Interval (Principale.Timer3,200);
  
        elsif Value(Principale.HScroll2) <= 4 then
          Interval (Principale.Timer3,400);
  
        elsif Value(Principale.HScroll2) <= 5 then
          Interval (Principale.Timer3,500);
  
        elsif Value(Principale.HScroll2) <= 6 then
          Interval (Principale.Timer3,1000);
  
        elsif Value(Principale.HScroll2) <= 7 then
          Interval (Principale.Timer3,1500);
  
        elsif Value(Principale.HScroll2) <= 8 then
          Interval (Principale.Timer3,2000);
  
        elsif Value(Principale.HScroll2) <= 9 then
          Interval (Principale.Timer3,3000);
  
        elsif Value(Principale.HScroll2) <= 10 then
          Interval (Principale.Timer3,5000);
  
        end if;
  
  
  end HScroll2_Scrolled;

  procedure HScroll1_Scrolled is
  begin
     
        -- Valeur 0
        if    Value(Principale.HScroll1) = 0 then
          --Vitesse 1 (le plus rapide)
          Interval (Principale.Timer1,1);
  
        -- Valeur 1
        elsif Value(Principale.HScroll1) = 1 then
          Interval (Principale.Timer1,5);
  
        -- Valeur 2
        elsif Value(Principale.HScroll1) = 2 then
          Interval (Principale.Timer1,10);
  
        -- Valeur 3
        elsif Value(Principale.HScroll1) = 3 then
          Interval (Principale.Timer1,50);
  
        -- Valeur 4
        elsif Value(Principale.HScroll1) = 4 then
          Interval (Principale.Timer1,100);
  
        -- Valeur 5
        elsif Value(Principale.HScroll1) = 5 then
          Interval (Principale.Timer1,200);
  
        -- Valeur 6
        elsif Value(Principale.HScroll1) = 6 then
          Interval (Principale.Timer1,300);
  
        -- Valeur 7
        elsif Value(Principale.HScroll1) = 7 then
          Interval (Principale.Timer1,500);
  
        -- Valeur 8
        elsif Value(Principale.HScroll1) = 8 then
          Interval (Principale.Timer1,1000);
  
        -- Valeur 9
        elsif Value(Principale.HScroll1) = 9 then
          Interval (Principale.Timer1,1500);
  
        end if;
  
  end HScroll1_Scrolled;

  procedure Sens_Click is
  begin
  
  if Value (Principale.Sens) /= gb.True then
    gb.Bitmap(Sens, LoadBitmapResource("TwoState1_Bitmap"));
  else
    gb.Bitmap(Sens, LoadBitmapResource("Image1_Bitmap"));
  end if;
  
  end Sens_Click;

  procedure Timer1_TimeEvent is
   
    begin
  
        -- Si le sens horaire est choisi via le bouton deux tats
        if Value (Principale.Sens) = gb.True then
  
          -- Si la bote d'image n'a pas atteint le bord droite de la fentre moins une marge de 50
          -- et qu'elle ne se trouve pas en bas de la fentre
          if Left(Principale.Image) < (Width(Principale.Form)-Width(Principale.Image)-50)
             and Top(Principale.Image)= 100 then
  
            -- Dplacer la fentre de 1 vers la droite
            Left(Principale.Image, Left(Principale.Image)+1);
  
          -- Si la bote d'image n'a pas atteint le bas de la fentre moins une marge de 50
          -- et qu'elle  se trouve  droite de la fentre
          elsif Top(Principale.Image) < (Height(Principale.Form)- Height(Principale.Image)-50)
                and Left(Principale.Image) = (Width(Principale.Form)-Width(Principale.Image)-50) then
  
            -- Dplacer la fentre de 1 vers le bas
            Top(Principale.Image, Top(Principale.Image)+1);
  
          -- Si la bote d'image a pas atteint le borb gauche de la fentre moins une marge de 50
          elsif Left(Principale.Image) > 50 then
   
  
            -- Dplacer la fentre de 1 vers la droite
            Left(Principale.Image, Left(Principale.Image)-1);
  
          -- Si la bote d'image a pas atteint le haut de la fentre moins une marge de 100 
          -- (pour le bouton et les barres de dfilement)
          elsif Top(Principale.Image) > 100 then
            Top(Principale.Image, Top(Principale.Image)-1);
            
          end if; 
  
       -- Si le sens horaire est choisi via le bouton deux tats
       else
  
         -- Si la bote d'image a pas atteint le borb gauche de la fentre moins une marge de 50
         -- et qu'elle ne se trouve pas en bas de la fentre
         if Left(Principale.Image) > 50 
            and Top(Principale.Image)= 100 then
  
            -- Dplacer la fentre de 1 vers la gauche
            Left(Principale.Image, Left(Principale.Image)-1);
  
         -- Si la bote d'image a pas atteint le bas de la fentre moins une marge de 50
         -- et qu'elle se trouve  gauche de la fentre
         elsif Top(Principale.Image) < (Height(Principale.Form)- Height(Principale.Image)-50)
               and Left(Principale.Image) = 50 then
  
            -- Dplacer la fentre de 1 vers la gauche
            Top(Principale.Image, Top(Principale.Image)+1);
  
         -- Si la bote d'image a pas atteint le bord droite de la fentre moins une marge de 50
         elsif Left(Principale.Image) < (Width(Principale.Form)- Width(Principale.Image)-50) then
  
           -- Dplacer la fentre de 1 vers la droite
           Left (Principale.Image, Left(Principale.Image)+1);
  
         -- Si la bote d'image a pas atteint le haut de la fentre moins une marge de 100
         elsif Top(Principale.Image) > 100 then
  
           -- Dplacer la fentre de 1 vers le haut
           Top(Principale.Image, Top(Principale.Image)-1);
        
        end if; 
      end if;
  end Timer1_TimeEvent;

  procedure Timer3_TimeEvent is
  begin
  
           if I = 1 then
              Visible (Principale.Box1, abs(Visible (Principale.Box1)-1));
              I:=I+1;
           elsif I = 2 then
              Visible (Principale.Box1, abs(Visible (Principale.Box1)-1));
              Visible (Principale.Box2, abs(Visible (Principale.Box2)-1));
    
              I:=I+1;
           elsif I = 3 then
              Visible (Principale.Box2, abs(Visible (Principale.Box2)-1));
              Visible (Principale.Box3, abs(Visible (Principale.Box3)-1));
     
              I:=I+1;
           elsif I = 4 then
              Visible (Principale.Box3, abs(Visible (Principale.Box3)-1));
              Visible (Principale.Box4, abs(Visible (Principale.Box4)-1));
    
              I:=I+1;         
           elsif I = 5 then             
              Visible (Principale.Box4, abs(Visible (Principale.Box4)-1));
              Visible (Principale.Box8, abs(Visible (Principale.Box8)-1));
    
              I:=I+1;
           elsif I = 6 then
              Visible (Principale.Box8, abs(Visible (Principale.Box8)-1));
              Visible (Principale.Box12, abs(Visible (Principale.Box12)-1));
    
              I:= I+1;
           elsif I = 7 then             
              Visible (Principale.Box12, abs(Visible (Principale.Box12)-1));
              Visible (Principale.Box11, abs(Visible (Principale.Box11)-1));
    
              I:=I+1;
           elsif I = 8 then             
              Visible (Principale.Box11, abs(Visible (Principale.Box11)-1));
              Visible (Principale.Box10, abs(Visible (Principale.Box10)-1));
    
              I:=I+1;
           elsif I = 9 then             
              Visible (Principale.Box10, abs(Visible (Principale.Box10)-1));
              Visible (Principale.Box9, abs(Visible (Principale.Box9)-1));
    
              I:=I+1;
           elsif I = 10 then             
              Visible (Principale.Box9, abs(Visible (Principale.Box9)-1));
              Visible (Principale.Box5, abs(Visible (Principale.Box5)-1));
    
              I:=I+1;
           elsif I = 11 then             
              Visible (Principale.Box5, abs(Visible (Principale.Box5)-1));
              Visible (Principale.Box1, abs(Visible (Principale.Box1)-1));
    
              I:=I+1;
           elsif I = 12 then             
              Visible (Principale.Box6, abs(Visible (Principale.Box6)-1));
       
              I:=I+1;
           elsif I = 13 then             
              Visible (Principale.Box11, abs(Visible (Principale.Box11)-1));
    
              I:=I+1;
           elsif I = 14 then             
              Visible (Principale.Box8, abs(Visible (Principale.Box8)-1));
       
              I:=I+1;
           elsif I = 15 then             
              Visible (Principale.Box3, abs(Visible (Principale.Box3)-1));
    
              I:=I+1;
           elsif I = 16 then             
              Visible (Principale.Box9, abs(Visible (Principale.Box9)-1));
    
              I:=I+1;
           elsif I = 17 then             
              Visible (Principale.Box10, abs(Visible (Principale.Box10)-1));
    
              I:=I+1;
    
           elsif I = 18 then             
              Visible (Principale.Box7, abs(Visible (Principale.Box7)-1));
              I:=I+1;
    
           elsif I = 19 then             
              Visible (Principale.Box4, abs(Visible (Principale.Box4)-1));
              I:=I+1;
    
           elsif I = 20 then             
              Visible (Principale.Box2, abs(Visible (Principale.Box2)-1));
              I:=I+1;
  
          elsif I = 21 then             
              Visible (Principale.Box5, abs(Visible (Principale.Box5)-1));
              I:=I+1;
  
          elsif I = 22 then             
              Visible (Principale.Box12, abs(Visible (Principale.Box12)-1));
              I:=1;
  
           end if;
  
  end Timer3_TimeEvent;

  procedure Initialize_Form is
  begin
    HScroll2.Scrolled := HScroll2_Scrolled'Access;
    SetScrollValues(HScroll2, 0, 10, 1, 1, 3);
    Move(HScroll2, 10, 30, 251, 21);

    HScroll1.Scrolled := HScroll1_Scrolled'Access;
    SetScrollValues(HScroll1, 0, 10, 1, 1, 0);
    Move(HScroll1, 300, 30, 251, 21);

    Caption(Label4, "Vitesse changement d'image");
    SetFont(Label4, "Times New Roman", 14, gb.False, gb.False, gb.False);
    Move(Label4, 29, 4, 212, 26);

    Caption(Label5, "-");
    SetFont(Label5, "Times New Roman", 14, gb.False, gb.False, gb.False);
    Move(Label5, 535, 10, 18, 19);

    Caption(Label6, "+");
    SetFont(Label6, "Times New Roman", 14, gb.False, gb.False, gb.False);
    Move(Label6, 306, 11, 18, 19);

    Bitmap(Image, LoadBitmapResource("Image_Bitmap"));
    Move(Image, 180, 120, 201, 151);

    Caption(Label1, "Vitesse de dfilement");
    SetFont(Label1, "Times New Roman", 15, gb.False, gb.False, gb.False);
    Move(Label1, 350, 0, 171, 21);

    Caption(Label3, "-");
    SetFont(Label3, "Times New Roman", 14, gb.False, gb.False, gb.False);
    Move(Label3, 244, 13, 18, 19);

    Caption(Label2, "+");
    SetFont(Label2, "Times New Roman", 14, gb.False, gb.False, gb.False);
    Move(Label2, 8, 11, 18, 19);

    Sens.Click := Sens_Click'Access;
    Bitmap(Sens, LoadBitmapResource("Sens_Bitmap"));
    Value(Sens, gb.True);
    Move(Sens, 580, 10, 151, 41);

    Border(Box3, gb.True);
    SetFont(Box3, "System", 10, gb.True, gb.False, gb.False);
    Move(Box3, 100, 0, 51, 51);
    Parent(Box3, Image);

    Border(Box2, gb.True);
    SetFont(Box2, "System", 10, gb.True, gb.False, gb.False);
    Move(Box2, 50, 0, 51, 51);
    Parent(Box2, Image);

    Border(Box9, gb.True);
    SetFont(Box9, "System", 10, gb.True, gb.False, gb.False);
    Move(Box9, 0, 100, 51, 51);
    Parent(Box9, Image);

    Border(Box12, gb.True);
    SetFont(Box12, "System", 10, gb.True, gb.False, gb.False);
    Move(Box12, 150, 100, 51, 51);
    Parent(Box12, Image);

    Border(Box8, gb.True);
    SetFont(Box8, "System", 10, gb.True, gb.False, gb.False);
    Move(Box8, 150, 50, 51, 51);
    Parent(Box8, Image);

    Border(Box11, gb.True);
    SetFont(Box11, "System", 10, gb.True, gb.False, gb.False);
    Move(Box11, 100, 100, 51, 51);
    Parent(Box11, Image);

    Border(Box7, gb.True);
    SetFont(Box7, "System", 10, gb.True, gb.False, gb.False);
    Move(Box7, 100, 50, 51, 51);
    Parent(Box7, Image);

    Border(Box10, gb.True);
    SetFont(Box10, "System", 10, gb.True, gb.False, gb.False);
    Move(Box10, 50, 100, 51, 51);
    Parent(Box10, Image);

    Border(Box6, gb.True);
    SetFont(Box6, "System", 10, gb.True, gb.False, gb.False);
    Move(Box6, 50, 50, 51, 51);
    Parent(Box6, Image);

    Border(Box5, gb.True);
    SetFont(Box5, "System", 10, gb.True, gb.False, gb.False);
    Move(Box5, 0, 50, 51, 51);
    Parent(Box5, Image);

    Border(Box4, gb.True);
    SetFont(Box4, "System", 10, gb.True, gb.False, gb.False);
    Move(Box4, 150, 0, 51, 51);
    Parent(Box4, Image);

    Border(Box1, gb.True);
    SetFont(Box1, "System", 10, gb.True, gb.False, gb.False);
    Move(Box1, 0, 0, 51, 51);
    Parent(Box1, Image);

    Bitmap(Image1, LoadBitmapResource("Image1_Bitmap"));
    Visible(Image1, gb.False);
    Move(Image1, 480, 130, 201, 101);

    Timer1.TimeEvent := Timer1_TimeEvent'Access;
    Interval(Timer1, 5);
    Enabled(Timer1, gb.True);
    Move(Timer1, 30, 220, 32, 29);

    Timer3.TimeEvent := Timer3_TimeEvent'Access;
    Interval(Timer3, 1000);
    Enabled(Timer3, gb.True);
    Move(Timer3, 30, 300, 32, 29);

    Caption(Form, "Principale");
    MinButton(Form, gb.False);
    SetColors(Form, Color(0, 0, 0), Color(191, 191, 191));
    Move(Form, 24, 148, 759, 500);
    Visible(Form, gb.True);
  end Initialize_Form;
begin
  Initialize_Form;
end Principale;


with gb;
with Principale;

procedure Main is begin
  gb.StartApplication;
end Main;


